'''Game main module.

Contains the entry point used by the run_game.py script.

Feel free to put all your game code here, or in other modules in this "lib"
directory.
'''

import data

import os
import pygame, math
from pygame.locals import *
import ode
from gameobject import *

world = ode.World()
space = ode.Space()
renderlist = []
player = None
rope = None
grapple = None
exit = None
gamestate = None


ropelength = 1.25
noMoreRope = 0

# Editor stuff :)
types = ((25,10),(50,10),(100,10),(150,10),(200,10),(250,10),(300,10), (400,10))
currType = 0
mode="XY"
buttons = Rect(69,462,100,28), Rect(652,463,80,28)
levels = os.listdir("data/levels")

def main(editor =0 ,levelName = None):
	#print "Hello from your game's main()"
	#print data.load('sample.txt').read()
	# Initialize pygame
	global gamestate, grapple, rope, exit, player, renderlist
	gamestate = 0
	pygame.init()
	level = 0
	sound = 1
	try:
		pygame.mixer.init()
	except:
		print "Mixer failed to initialize"
		sound = 0
	# Open a display
	srf = pygame.display.set_mode((800,600))
	main = pygame.image.load("data\mainscreen.png")
	srf.blit(main, (0,0,800,600))
	while gamestate == 0:
		if levelName and editor == 1:
		    gamestate = 1
		else:
			if levelName:
				gamestate = 1
				level += 1
				levelName = levels[level]
			else:    
				for event in pygame.event.get():
					if event.type == MOUSEBUTTONDOWN:
						if buttons[1].collidepoint(pygame.mouse.get_pos()):
							gamestate = 2
						elif buttons[0].collidepoint(pygame.mouse.get_pos()):
							if not levelName:
								levelName = levels[level]
								gamestate = 1
					if event.type == QUIT:
						gamestate = 2

		if gamestate == 1:
			if sound == 1:
				pygame.mixer.music.load("Data/music.ogg")
				pygame.mixer.music.play(-1)
			world.setGravity((0,0.98,0))
			playerLine = None
			
			renderlist = []
			rope = None
			player = None
			#~ # Connect body1 with the static environment
			#~ j1 = ode.BallJoint(world)
			#~ j1.attach(body1, ode.environment)
			#~ j1.setAnchor( (-1,2,0) )
			if levelName != None:
				if editor == 1:
					write = "w"
				else:
					write = "r"
				f = open("Data/Levels/" + levelName,write )
				playerLine = f.readline()
				if playerLine:
					playX,playY = playerLine.split(",")
				else:
					playX, playY = (400,300)
					
				exitLine = f.readline()
				if exitLine:
					exitX, exitY = exitLine.split(",")
				else:
					exitX, exitY = (780,20)
				#print playX, playY
			# Create Player
			playPos = (float(playX),float(playY))
			#print playPos
			player = Player(playPos)
			obstacles = []
			exit = Exit((float(exitX),float(exitY)))
			if not playerLine:
				floor = GameObject((800,5),(400,598))
				ceiling = GameObject((800,5),(400,2))
				lwall = GameObject((5,600),(2,300))
				rwall = GameObject((5,600),(798,300))
				obstacles.append(floor)
				obstacles.append(ceiling)
				obstacles.append(lwall)
				obstacles.append(rwall)
			else:
				while 1:
					line = f.readline()
					if not line:
						break
					dim, cent = line.split(":")
					dimX, dimY = dim.split(",")
					centX,centY = cent.split(",")
					dimensions = (float(dimX),float(dimY))
					centre = (float(centX),float(centY))
					obj = GameObject(dimensions, centre)
					obstacles.append(obj)
				f.close()

			#obstacles.append(obj)
			#obstacles.append(obj2)
			#obstacles.append(obj3)
			
			# A joint group for the contact joints that are generated whenever
			# two bodies collide
			contactgroup = ode.JointGroup()
			# Simulation loop...

			#fps = 15
			#dt = 1.0/fps
			loopFlag = True
			clk = pygame.time.Clock()
			#print space.getNumGeoms()
			fps = 60
			if editor == 1:
				print "Editor Mode Active"
				global types, currType, mode
				print types[currType]
				print mode
			while gamestate == 1:
				pygame.display.set_caption("Rope Swing Game!  Current FPS: " + str(fps))
				# Detect collisions and create contact joints
				handleCollisions(obstacles, contactgroup)
				if editor == 0:
					checkExit()
				#space.collide((world,contactgroup), near_callback)
				if rope!= None:
					grapple = None
				if grapple:
					x1,y1,z1 = player.body.getPosition()
					x2,y2,z2 = grapple.getPosition()
					vUp = (x2-x1,y2-y1)			
					magvUp = math.sqrt(vUp[0]**2 + vUp[1]**2)
					if magvUp > ropelength:
						del grapple.geom
						del grapple
						grapple = None
					
				events = pygame.event.get()
				for e in events:
					if e.type==QUIT:
						gamestate = 2
					if e.type==KEYDOWN:
						if e.key == K_SPACE:
							if rope == None and grapple == None:
								grapple = Grapple(world)
								#rope = Rope(player, (400,100))
							else:
								if rope:
									del rope.joint
									rope = None
								#~ if grapple:
									#~ del grapple.geom
									#~ grapple = None
							#drawrope = 0
						if editor ==1:
							if e.key == K_PAGEUP:
								currType += 1
								currType = (currType % len(types))
								print types[currType]
							if e.key == K_PAGEDOWN:
								currType -= 1
								currType = (currType % len(types))					
								print types[currType]
							if e.key == K_HOME:
								mode = "XY"
								print mode
							if e.key == K_END:
								mode = "YX"
								print mode
							if e.key == K_s:
								print "Saving"
								if levelName != None:
									Save(playPos, exit, obstacles, levelName)
								else:
									Save(playPos, exit, obstacles, "level.txt")
							if e.key == K_p:
								playPos = pygame.mouse.get_pos()
								print "Player start point set to " + str(playPos)
							if e.key == K_x:
								exit.centre = pygame.mouse.get_pos()
								print "Exit set to " + str(exit)
					if editor == 1:
						if e.type == MOUSEBUTTONDOWN:
							if mode == "XY":
								editorObj = GameObject(types[currType], pygame.mouse.get_pos())
							else:
								editorObj = GameObject((types[currType][1],types[currType][0]), pygame.mouse.get_pos())                        
							obstacles.append(editorObj)
				

				KP = pygame.key.get_pressed()
				if KP[K_LEFT] == 1:
					player.body.addForce((-0.15,0,0))
				if KP[K_RIGHT] == 1:
					player.body.addForce((0.15,0,0))
				if KP[K_UP] == 1:
					if rope != None:
						x1,y1,z1 = player.body.getPosition()
						x2,y2,z2 = rope.joint.getAnchor()
						vUp = (x2-x1,y2-y1)
						magvUp = math.sqrt(vUp[0]**2 + vUp[1]**2)
						#print magvUp
						if magvUp > 0.15:
							vUpUnit = vUp[0]/(magvUp * 200),vUp[1]/(magvUp * 100)
							x1 = x1 + vUpUnit[0]
							y1 = y1 + vUpUnit[1]
							player.body.setPosition((x1,y1,z1))
							c = rope.coords
							del rope.joint
							del rope
							rope = Rope(player, c)
				if KP[K_DOWN]== 1:
					if rope != None:
						x1,y1,z1 = player.body.getPosition()
						x2,y2,z2 = rope.joint.getAnchor()
						vUp = (x2-x1,y2-y1)
					
						magvUp = math.sqrt(vUp[0]**2 + vUp[1]**2)
						if magvUp < ropelength and noMoreRope == 0:
							vUpUnit = vUp[0]/(magvUp * 100),vUp[1]/(magvUp * 100)
							x1 = x1 - vUpUnit[0]
							y1 = y1 - vUpUnit[1]
							c = rope.coords
							del rope.joint
							del rope
							player.body.setPosition((x1,y1,z1))
							rope = Rope(player, c)
							
						
				# Clear the screen
				srf.fill((255,255,255))

				for object in renderlist:
					object.draw(srf)

				if rope:
					rope.draw(srf)
				if grapple:
					grapple.draw(srf)
				#obj.draw(srf)

				pygame.display.flip()

				# Next simulation step
				if fps != 0:
					world.step(1.0/fps)
				contactgroup.empty()
				# Try to keep the specified framerate    
				clk.tick()
				fps = clk.get_fps()
		pygame.display.flip()

def handleCollisions(obstacles, contactgroup):
	global player, grapple, rope, noMoreRope, exit, gamestate
	collidingNow = 0
	for obstacle in obstacles:
		if grapple != None:
			contacts = ode.collide(obstacle.geom, grapple.geom)

			if len(contacts) >0:
				#print "Grapple!"
				grapple.geom.disable()
				grapple.geom.getBody().disable()
				pos = contacts[0].getContactGeomParams()[0]#grapple.geom.getPosition()
				rope = Rope(player, (pos[0]*200, pos[1]*200))
			
		contacts = ode.collide(obstacle.geom, player.geom)
		if len(contacts) > 0:
			for c in contacts:
				c.setBounce(0.75)
				c.setMu(0.5)
				j = ode.ContactJoint(world, contactgroup, c)
				j.attach(obstacle.geom.getBody(), player.body)				
				noMoreRope = 1
				collidingNow = 1

	if collidingNow == 0:
		noMoreRope = 0
		

def checkExit():
	contacts = ode.collide(player.geom, exit.geom)
	if len(contacts) > 0:
		global gamestate
		gamestate = 0

#
# Save the level into a text file.
#
def Save(playPos, exit, obstacles, levelName):	
    e = exit.centre
    f = open("data/levels/" + levelName, "w")
    f.write(str(playPos[0]) + "," + str(playPos[1]) + "\n")
    f.write(str(e[0]) + "," + str(e[1]) + "\n")
    for obstacle in obstacles:
        f.write(str(obstacle.dimensions[0]) + "," + str(obstacle.dimensions[1]) + ":" + str(obstacle.centre[0]) + "," + str(obstacle.centre[1]) + "\n")
    f.close()

if __name__ == "__main__":
	main()